library ptwebserver.extHandler.PHP;

import '../extHandler.dart';
import '../config.dart';
import 'dart:io';
import 'dart:convert';

/*
 * Handles PHP file requests, if we don't it should be passed off to the default handler
 */
class PHP_Handler extends extHandler {
  PHP_Handler() {
    // PHP has been initialized
  }
  
  static RegExp PHP_REGEX = new RegExp(r"/\.php$/i");
  
  String get Name=>"PHP";
  
  static const String phpPath = "php"; 
  
  static Directory path = Directory.current;
  static String getMyPath() => "${(path.path)}/packages/ptwebserver/resource";
  
  
  /*
   * Check to make sure we have tested for PHP
   * If we have, and it exist and the file is PHP, then true, otherwise false
   */
  bool test(String file) {
    if(!phpExistTest) {
      checkForPHP();
    }
    return (exists && file.toLowerCase().endsWith(".php"));
  }
  
  bool phpExistTest = false;
  bool exists = false;
  
  
  /*
   * We handle the PHP request
   * We have a php File that we use to pass our settings to the request file.
   * Only supports GET and POST methods. We do not pass any other data to the 
   * PHP such as other header information currently.
   * 
   */
  void handle(ptHost host,HttpRequest req,String file) {
    List<String> args = new List<String>();
    args.add("-n");
    args.add("${getMyPath()}/phpExecute.php");
    args.add(file);
    args.add(req.method);
    req.uri.queryParameters.forEach((key,val) {
      args.add("${key}=${val}");
    });
    Process.start(phpPath, args).then((Process proc) {
      proc.stdout.transform(new Utf8Decoder()).listen((data) {
        req.response.write(data);
      }, onDone: () {
        req.response.close();
      });
    });
  }
  
  /*
   * We use the whereis to check for the location of php.
   * If the length of output is greater than "php: "'s length, then we SHOULD
   */
  void checkForPHP() {
    String out = Process.runSync("whereis", ["php"], stdoutEncoding: UTF8).stdout;
    if(out.length > "php: ".length) {
      phpExistTest = true;
      exists = true;
    } else {
      phpExistTest = true;
      exists = true;
    }
  }
}